//  ------------------------ Drop Down Menu --------------------------------
//                by Carl Paulson      Cognitive Portals
//                 http://members.tripod.com/~SleepyCP/
//                          cpaulson@home.com
//        This was an attempt to replicate the "link.class" methods.
//  ---------------------------------------------------------------------
//
//  Suggested HTML Input:
/*
<APPLET code="Button1.class" width=205 height=72

    <param name=numURLs     value="7">
    <param name=WinTarget   value="_parent">

    <param name=aURLin0     value="NJ & Pa Skiing Links|Not a Link">
    <param name=aURLin1     value="Jack Frost - Big Boulder|http://209.182.34.181/skiing/passes.html">
    <param name=aURLin2     value="Vernon Valley - Great Gorge|http://www.aminews.com/weather/ski_areas/Vernon_Valley_Great_Gorge_NJ_US.shtml">
    <param name=aURLin3     value="Shawnee|http://www.shawneemt.com/">
    <param name=aURLin4     value="Camelback|http://ski-guide.com/cgi-bin/ski.exe/skitext/pa07">
    <param name=aURLin5     value="Belle Mountain|http://skiresortguide.com/cgi-bin/skiarea.exe/overview/nj02">
    <param name=aURLin6     value="Hunter Mountain|http://www.huntermtn.com/">

    <param name=BG_Color    value="blue">

    <CENTER><FONT SIZE=3>{If you can read this, your browser 
    dosen`t support Java.}</FONT><BR>
    <FONT FACE="Helvetica" COLOR="#FF0000" SIZE=7>(Drop Down Menu
    Applet)</FONT></CENTER><BR>
</APPLET>
*/
//
//  ---------------------------------------------------------------------

import java.util.*;
import java.net.*;
import java.awt.*;
import java.applet.Applet;

//  ---------------------------------------------------------------------

public class DD_Menu extends Applet {

    private boolean debug   = true;
    private int     numOfURLs;
    private Vector  theURL  = new Vector();
    private Vector  URLName = new Vector();
    private String  Target;
    public  Choice  theChoice;
    private Panel   p1;
    private Color   ColorFG,    ColorFG1,   ColorBG;
    private URL     theURL1;
    private StringTokenizer StrTok;
    private FontMetrics     fMetric;

//-----------------------------------------------------------------------

    public void init() {

        ColorBG   = getColorParam("BG_Color",  "Black");

        numOfURLs = getIntParam("numURLs",1,0,20);

        Target    = null;
        Target    = getParameter("WinTarget");
        if (Target == null) Target = "_parent";

        theChoice = new Choice();
        for ( int i = 0; i < numOfURLs; i++) {
            if ( debug ) System.out.println("init "+i);
            String Tin  = "aURLin" + i;
            String Test = getParameter(Tin);
            StrTok      = new StringTokenizer(Test, "|");

            try {
                URLName.addElement(new String(StrTok.nextToken()));
            } catch (NoSuchElementException e) {
                System.out.println("Link "+i+" Name is NULL");
                URLName.addElement(" ");
            }

            try {
                theURL.addElement(new String(StrTok.nextToken()));
            } catch (NoSuchElementException e) {
                System.out.println("Link "+i+" URL is Null");
                theURL.addElement(" ");
            }

            try {
                theChoice.addItem((String)URLName.elementAt(i));
            } catch (NullPointerException e) { 
                System.out.println("Link "+i+" URL name is illegimate");
                theChoice.addItem(" ");
            }

        }
        setLayout(new GridBagLayout());
        setBackground(ColorBG);
        p1 = new Panel();
        GridBagLayout gl = new GridBagLayout();
        p1.setLayout(gl);
        GridBagConstraints gc = new GridBagConstraints();
        gc.gridwidth  = 1;
        gc.fill       = GridBagConstraints.BOTH;
        gc.weightx    = 1.0;
        gc.gridwidth  = 1;
        gc.gridx      = 0;
        gc.gridy      = 0;
        gl.setConstraints(theChoice, gc);
        p1.add("center",theChoice);

        resize (155,31);
        add("Center",p1);
        resize (150,31);
        setBackground(ColorBG);
    }

//-----------------------------------------------------------------------

    public boolean action(Event evt, Object Arg) {
        if(evt.target instanceof Choice) {
            String Name1 = theChoice.getSelectedItem();
//          String Name1 = (String) Arg;
            for(int i = 0; i <= numOfURLs; i++) {
                if(Name1.equals((String)URLName.elementAt(i))) {
                    try {
                        theURL1 = new URL((String)theURL.elementAt(i)); 
                    } catch(MalformedURLException e) { 
                        System.out.println("Invalid URL: Number = "+i);
theChoice.select(0);
                    }
                    getAppletContext().showDocument(theURL1,Target);
                }
            }
        }
        return true;
    }

// -------------------------- getColor ----------------------------------

    public Color getColorParam(String c, String def_C) {

        Color Color1 = Color.lightGray;      // default color
        if (def_C != null) {
            if      (def_C.equalsIgnoreCase("black"))     Color1 = Color.black;
            else if (def_C.equalsIgnoreCase("blue"))      Color1 = Color.blue;
            else if (def_C.equalsIgnoreCase("cyan"))      Color1 = Color.cyan;
            else if (def_C.equalsIgnoreCase("darkGray"))  Color1 = Color.darkGray;
            else if (def_C.equalsIgnoreCase("gray"))      Color1 = Color.gray;
            else if (def_C.equalsIgnoreCase("green"))     Color1 = Color.green;
            else if (def_C.equalsIgnoreCase("lightGray")) Color1 = Color.lightGray;
            else if (def_C.equalsIgnoreCase("magenta"))   Color1 = Color.magenta;
            else if (def_C.equalsIgnoreCase("orange"))    Color1 = Color.orange;
            else if (def_C.equalsIgnoreCase("pink"))      Color1 = Color.pink;
            else if (def_C.equalsIgnoreCase("red"))       Color1 = Color.red;
            else if (def_C.equalsIgnoreCase("white"))     Color1 = Color.white;
            else if (def_C.equalsIgnoreCase("yellow"))    Color1 = Color.yellow;
        }

        StringTokenizer st;
        String rgbDelim = ":,.";
        String c_str = getParameter(c);
        if (c_str != null) st = new StringTokenizer(c, rgbDelim);
        else return Color1;

        if      (c_str.equalsIgnoreCase("black"))     return Color.black;
        else if (c_str.equalsIgnoreCase("blue"))      return Color.blue;
        else if (c_str.equalsIgnoreCase("cyan"))      return Color.cyan;
        else if (c_str.equalsIgnoreCase("darkGray"))  return Color.darkGray;
        else if (c_str.equalsIgnoreCase("gray"))      return Color.gray;
        else if (c_str.equalsIgnoreCase("green"))     return Color.green;
        else if (c_str.equalsIgnoreCase("lightGray")) return Color.lightGray;
        else if (c_str.equalsIgnoreCase("magenta"))   return Color.magenta;
        else if (c_str.equalsIgnoreCase("orange"))    return Color.orange;
        else if (c_str.equalsIgnoreCase("pink"))      return Color.pink;
        else if (c_str.equalsIgnoreCase("red"))       return Color.red;
        else if (c_str.equalsIgnoreCase("white"))     return Color.white;
        else if (c_str.equalsIgnoreCase("yellow"))    return Color.yellow;

        else if (st.countTokens() == 3) {
            Integer r = new Integer(st.nextToken());
            Integer g = new Integer(st.nextToken());
            Integer b = new Integer(st.nextToken());
            Color1    = new Color(r.intValue(), g.intValue(), b.intValue());
            return Color1;
            }
        return Color1;
    }

// -------------------------- getString ---------------------------------

    public String getStringParam(String x, String def_X) {
        String str;
        str = getParameter(x);
        if (str == null) str = def_X;
        return str;
    }

// ------------------------- getInteger ---------------------------------

    public int getIntParam(String i, int def_I, int min_i, int max_i) {
        int i_in;
        try {
            i_in = Integer.parseInt(getParameter(i));
            if ((i_in < min_i)||(i_in > max_i)) throw new Exception();
        } catch (Exception e) {
            System.out.println(i+" invalid; using default value: "+def_I);
            i_in = def_I;
        }	
        return i_in;
    }

    // -------------------------- getFont  ------------------------------

    public Font getFontParam(String fnt, String def_Fnt, 
            String Style, int def_Style, String Size, int def_Size) {

        String font_Name  = getStringParam(fnt,   def_Fnt);
        int    font_Style = getIntParam   (Style, def_Style, 0, 3);
        int    font_Size  = getIntParam   (Size,  def_Size, 4, 100);

        return (new Font(font_Name, font_Style, font_Size));
    }

}

// ######################################################################
